POJ 3126 Prime Path(BFS)

题目链接:http://poj.org/problem?id=3126

题目大意: 给定两个四位素数a b,求a变换到b需要几步,并且变化时只有一个数字不同且为四位数,并且是素数

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source


思路:先将10000以内素数打表,然后BFS枚举每一位求最短素数路径


代码:

#include<cstdio>
#include<cmath>
#include<cstring>
#include<string>
#include<cstdlib>
#include<algorithm>
#include<iostream>
#include<queue>
#include<stack>
#include<map>

using namespace std;

#define FOU(i,x,y) for(int i=x;i<=y;i++)
#define FOD(i,x,y) for(int i=x;i>=y;i--)
#define MEM(a,val) memset(a,val,sizeof(a))
#define PI acos(-1.0)

const double EXP = 1e-9;
typedef long long ll;
typedef unsigned long long ull;
const int INF = 0x3f3f3f3f;
const ll MINF = 0x3f3f3f3f3f3f3f3f;
const int mod = 1e9+7;
const int N = 1e4+5;

int prime[N];  //第i个素数是prime[i],从0开始记录
int vis[N];  //vis[i]代表当前合数被筛过没有,保证每个合数只被筛一次
bool is_prime[N];  //is_prime[i]为true代表i是素数

int euler(int n)  //筛出小于等于n的所有素数并返回个数
{
    int cnt=0;  //记录个数
    for(int i=0;i<=n;i++)
    {
        vis[i]=0;
        is_prime[i]=false;
    }
    for(int i=2;i<=n;i++)
    {
        if(vis[i]==0)
        {
            prime[cnt++]=i;
            is_prime[i]=true;
        }
        for(int j=0;j<cnt&&i*prime[j]<=n;j++)
        {
            vis[i*prime[j]]=1;
            if(i%prime[j]==0)
                break;
        }
    }
    return cnt;
}

int visit[N];

struct node
{
    int num;
    int step;
};

int cg1(int num,int x)  //将num第一位变为x
{
    return (x*1000)+(num%1000);
}

int cg2(int num,int x)  //将num第二位变为x
{
    int tmp=num/1000;
    return (tmp*1000)+(x*100)+(num%100);
}

int cg3(int num,int x)  //将num第三位变为x
{
    int tmp=num/100;
    return (tmp*100)+(x*10)+(num%10);
}

int cg4(int num,int x)  //将num第四位变为x
{
    int tmp=num/10;
    return tmp*10+x;
}

int bfs(int x,int y)
{
    MEM(visit,0);
    node now,next;
    now.num=x;
    now.step=0;
    visit[x]=1;
    queue<node>q;
    q.push(now);
    while(!q.empty())
    {
        now=q.front();
        q.pop();
        if(now.num==y)
            return now.step;
        for(int i=1;i<=9;i++) //改变第一位
        {
            next.num=cg1(now.num,i);
            next.step=now.step+1;
            if(is_prime[next.num]==true&&visit[next.num]==0)
            {
                visit[next.num]=1;
                q.push(next);
            }
        }
        for(int i=0;i<=9;i++) //改变第二位
        {
            next.num=cg2(now.num,i);
            next.step=now.step+1;
            if(is_prime[next.num]==true&&visit[next.num]==0)
            {
                visit[next.num]=1;
                q.push(next);
            }
        }
        for(int i=0;i<=9;i++) //改变第三位
        {
            next.num=cg3(now.num,i);
            next.step=now.step+1;
            if(is_prime[next.num]==true&&visit[next.num]==0)
            {
                visit[next.num]=1;
                q.push(next);
            }
        }
        for(int i=0;i<=9;i++) //改变第四位
        {
            next.num=cg4(now.num,i);
            next.step=now.step+1;
            if(is_prime[next.num]==true&&visit[next.num]==0)
            {
                visit[next.num]=1;
                q.push(next);
            }
        }
    }
    return -1;
}

int main()
{
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    //std::ios::sync_with_stdio(false);
    int xx=euler(10000);
    int t;
    int x,y;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&x,&y);
        int ans=bfs(x,y);
        if(ans==-1)
            printf("Impossible\n");
        else
            printf("%d\n",ans);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值